#

API Docs for: v3.8.1
Show: Inherited Protected Private Deprecated

# DS.RESTSerializer Class

Extends DS.JSONSerializer
Defined in: `addon/serializers/rest.js:20`
Module: ember-data

Normally, applications will use the `RESTSerializer` by implementing the `normalize` method.

This allows you to do whatever kind of munging you need and is especially useful if your server is inconsistent and you need to do munging differently for many different kinds of responses.

See the `normalize` documentation for more information.

## Across the Board Normalization

There are also a number of hooks that you might find useful to define across-the-board rules for your payload. These rules will be useful if your server is consistent, or if you're building an adapter for an infrastructure service, like Firebase, and want to encode service conventions.

For example, if all of your keys are underscored and all-caps, but otherwise consistent with the names you use in your models, you can implement across-the-board rules for how to convert an attribute name in your model to a key in your JSON.

    import DS from 'ember-data';
    import { underscore } from '@ember/string';

    export default DS.RESTSerializer.extend({
      keyForAttribute(attr, method) {
        return underscore(attr).toUpperCase();
      }
    });

You can also implement `keyForRelationship`, which takes the name of the relationship as the first parameter, the kind of relationship (`hasMany` or `belongsTo`) as the second parameter, and the method (`serialize` or `deserialize`) as the third parameter.

- Index
- Methods
- Properties

## Item Index

### Methods

- _canSerialize
- _getMappedKey
- _mustSerialize
- _normalizeArray
- _normalizeResponse
- applyTransforms
- extractAttributes
- extractErrors
- extractId
- extractMeta
- extractPolymorphicRelationship
- extractRelationship
- extractRelationships
- keyForAttribute
- keyForLink
- keyForPolymorphicType
- keyForRelationship
- modelNameFromPayloadKey
- normalize
- normalizeArrayResponse
- normalizeCreateRecordResponse
- normalizeDeleteRecordResponse
- normalizeFindAllResponse
- normalizeFindBelongsToResponse
- normalizeFindHasManyResponse
- normalizeFindManyResponse
- normalizeFindRecordResponse
- normalizeQueryRecordResponse
- normalizeQueryResponse
- normalizeRelationships
- normalizeResponse
- normalizeSaveResponse
- normalizeSingleResponse
- normalizeUpdateRecordResponse
- normalizeUsingDeclaredMapping
- payloadKeyFromModelName
- pushPayload
- serialize
- serializeAttribute
- serializeBelongsTo
- serializeHasMany
- serializeIntoHash
- serializePolymorphicType
- shouldSerializeHasMany
- transformFor

### Properties

- attrs
- primaryKey
- store

## Methods

### `_canSerialize`

(

- `key`

)
Boolean private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:829`

Check attrs.key.serialize property to inform if the `key` can be serialized

#### Parameters:

- `key` String

#### Returns:

Boolean:

true if the key can be serialized

### `_getMappedKey`

(

- `key`

)
String private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:790`

Looks up the property key that was set by the custom `attr` mapping passed to the serializer.

#### Parameters:

- `key` String

#### Returns:

String:

key

### `_mustSerialize`

(

- `key`

)
Boolean private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:844`

When attrs.key.serialize is set to true then it takes priority over the other checks and the related attribute/relationship will be serialized

#### Parameters:

- `key` String

#### Returns:

Boolean:

true if the key must be serialized

### `_normalizeArray`

(

- `store`
- `modelName`
- `arrayHash`
- `prop`

)
Object private

Defined in `addon/serializers/rest.js:162`

Normalizes an array of resource payloads and returns a JSON-API Document with primary data and, if any, included data as `{ data, included }`.

#### Parameters:

- `store` DS.Store
- `modelName` String
- `arrayHash` Object
- `prop` String

#### Returns:

Object:

### `_normalizeResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`
- `isSingle`

)
Object private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:446`

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String
- `isSingle` Boolean

#### Returns:

Object:

JSON-API Document

### `applyTransforms`

(

- `typeClass`
- `data`

)
Object private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:175`

Given a subclass of `DS.Model` and a JSON object this method will iterate through each attribute of the `DS.Model` and invoke the `DS.Transform#deserialize` method on the matching property of the JSON object. This method is typically called after the serializer's `normalize` method.

#### Parameters:

- `typeClass` DS.Model
- `data` Object

  The data to transform

#### Returns:

Object:

data The transformed data object

### `extractAttributes`

(

- `modelClass`
- `resourceHash`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:572`

Returns the resource's attributes formatted as a JSON-API "attributes object".

http://jsonapi.org/format/#document-resource-object-attributes

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

Object:

### `extractErrors`

(

- `store`
- `typeClass`
- `payload`
- `id`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1306`

`extractErrors` is used to extract model errors when a call to `DS.Model#save` fails with an `InvalidError`. By default Ember Data expects error information to be located on the `errors` property of the payload object.

This serializer expects this `errors` object to be an Array similar to the following, compliant with the https://jsonapi.org/format/#errors specification:

    {
      "errors": [
        {
          "detail": "This username is already taken!",
          "source": {
            "pointer": "data/attributes/username"
          }
        }, {
          "detail": "Doesn't look like a valid email.",
          "source": {
            "pointer": "data/attributes/email"
          }
        }
      ]
    }

The key `detail` provides a textual description of the problem. Alternatively, the key `title` can be used for the same purpose.

The nested keys `source.pointer` detail which specific element of the request data was invalid.

Note that JSON-API also allows for object-level errors to be placed in an object with pointer `data`, signifying that the problem cannot be traced to a specific attribute:

    {
      "errors": [
        {
          "detail": "Some generic non property error message",
          "source": {
            "pointer": "data"
          }
        }
      ]
    }

When turn into a `DS.Errors` object, you can read these errors through the property `base`:

    {{#each model.errors.base as |error|}}
      <div class="error">
        {{error.message}}
      </div>
    {{/each}}

Example of alternative implementation, overriding the default behavior to deal with a different format of errors:

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      extractErrors(store, typeClass, payload, id) {
        if (payload && typeof payload === 'object' && payload._problems) {
          payload = payload._problems;
          this.normalizeErrors(typeClass, payload);
        }
        return payload;
      }
    });

#### Parameters:

- `store` DS.Store
- `typeClass` DS.Model
- `payload` Object
- `id` (String | Number)

#### Returns:

Object:

json The deserialized errors

### `extractId`

(

- `modelClass`
- `resourceHash`

)
String

Inherited from DS.JSONSerializer: `addon/serializers/json.js:558`

Returns the resource's ID.

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

String:

### `extractMeta`

(

- `store`
- `modelClass`
- `payload`

)

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1272`

`extractMeta` is used to deserialize any meta information in the adapter payload. By default Ember Data expects meta information to be located on the `meta` property of the payload object.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      extractMeta(store, typeClass, payload) {
        if (payload && payload.hasOwnProperty('_pagination')) {
          let meta = payload._pagination;
          delete payload._pagination;
          return meta;
        }
      }
    });

#### Parameters:

- `store` DS.Store
- `modelClass` DS.Model
- `payload` Object

### `extractPolymorphicRelationship`

(

- `relationshipType`
- `relationshipHash`
- `relationshipOptions`

)
Object

Inherited from DS.JSONSerializer but overwritten in `addon/serializers/rest.js:757`

You can use this method to customize how a polymorphic relationship should be extracted.

#### Parameters:

- `relationshipType` Object
- `relationshipHash` Object
- `relationshipOptions` Object

#### Returns:

Object:

### `extractRelationship`

(

- `relationshipModelName`
- `relationshipHash`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:596`

Returns a relationship formatted as a JSON-API "relationship object".

http://jsonapi.org/format/#document-resource-object-relationships

#### Parameters:

- `relationshipModelName` Object
- `relationshipHash` Object

#### Returns:

Object:

### `extractRelationships`

(

- `modelClass`
- `resourceHash`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:653`

Returns the resource's relationships formatted as a JSON-API "relationships object".

http://jsonapi.org/format/#document-resource-object-relationships

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

Object:

### `keyForAttribute`

(

- `key`
- `method`

)
String

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1417`

`keyForAttribute` can be used to define rules for how to convert an attribute name in your model to a key in your JSON.

Example

    import DS from 'ember-data';
    import { underscore } from '@ember/string';

    export default DS.RESTSerializer.extend({
      keyForAttribute(attr, method) {
        return underscore(attr).toUpperCase();
      }
    });

#### Parameters:

- `key` String
- `method` String

#### Returns:

String:

normalized key

### `keyForLink`

(

- `key`
- `kind`

)
String

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1471`

`keyForLink` can be used to define a custom key when deserializing link properties.

#### Parameters:

- `key` String
- `kind` String

  `belongsTo` or `hasMany`

#### Returns:

String:

normalized key

### `keyForPolymorphicType`

(

- `key`
- `typeClass`
- `method`

)
String

Defined in `addon/serializers/rest.js:64`

`keyForPolymorphicType` can be used to define a custom key when serializing and deserializing a polymorphic type. By default, the returned key is `${key}Type`.

Example

    import DS from 'ember-data';

    export default DS.RESTSerializer.extend({
      keyForPolymorphicType(key, relationship) {
        var relationshipKey = this.keyForRelationship(key);

        return 'type-' + relationshipKey;
      }
    });

#### Parameters:

- `key` String
- `typeClass` String
- `method` String

#### Returns:

String:

normalized key

### `keyForRelationship`

(

- `key`
- `typeClass`
- `method`

)
String

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1443`

`keyForRelationship` can be used to define a custom key when serializing and deserializing relationship properties. By default `JSONSerializer` does not provide an implementation of this method.

Example

    import DS from 'ember-data';
    import { underscore } from '@ember/string';

    export default DS.JSONSerializer.extend({
      keyForRelationship(key, relationship, method) {
        return rel_${underscore(key)};
      }
    });

#### Parameters:

- `key` String
- `typeClass` String
- `method` String

#### Returns:

String:

normalized key

### `modelNameFromPayloadKey`

(

- `key`

)
String

Inherited from DS.JSONSerializer but overwritten in `addon/serializers/rest.js:434`

This method is used to convert each JSON root key in the payload into a modelName that it can use to look up the appropriate model for that part of the payload.

For example, your server may send a model name that does not correspond with the name of the model in your app. Let's take a look at an example model, and an example payload:

    import DS from 'ember-data';

    export default DS.Model.extend({
    });

      {
        "blog/post": {
          "id": "1
        }
      }

Ember Data is going to normalize the payload's root key for the modelName. As a result, it will try to look up the "blog/post" model. Since we don't have a model called "blog/post" (or a file called app/models/blog/post.js in ember-cli), Ember Data will throw an error because it cannot find the "blog/post" model.

Since we want to remove this namespace, we can define a serializer for the application that will remove "blog/" from the payload key whenver it's encountered by Ember Data:

    import DS from 'ember-data';

    export default DS.RESTSerializer.extend({
      modelNameFromPayloadKey(payloadKey) {
        if (payloadKey === 'blog/post') {
          return this._super(payloadKey.replace('blog/', ''));
        } else {
         return this._super(payloadKey);
        }
      }
    });

After refreshing, Ember Data will appropriately look up the "post" model.

By default the modelName for a model is its name in dasherized form. This means that a payload key like "blogPost" would be normalized to "blog-post" when Ember Data looks up the model. Usually, Ember Data can use the correct inflection to do this for you. Most of the time, you won't need to override `modelNameFromPayloadKey` for this purpose.

#### Parameters:

- `key` String

#### Returns:

String:

the model's modelName

### `normalize`

(

- `modelClass`
- `resourceHash`
- `prop`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/rest.js:95`

Normalizes a part of the JSON payload returned by the server. You should override this method, munge the hash and call super if you have generic normalization to do.

It takes the type of the record that is being normalized (as a DS.Model class), the property where the hash was originally found, and the hash to normalize.

For example, if you have a payload that looks like this:

    {
      "post": {
        "id": 1,
        "title": "Rails is omakase",
        "comments": [ 1, 2 ]
      },
      "comments": [{
        "id": 1,
        "body": "FIRST"
      }, {
        "id": 2,
        "body": "Rails is unagi"
      }]
    }

The `normalize` method will be called three times:

- With `App.Post`, `"posts"` and `{ id: 1, title: "Rails is omakase", ... }`
- With `App.Comment`, `"comments"` and `{ id: 1, body: "FIRST" }`
- With `App.Comment`, `"comments"` and `{ id: 2, body: "Rails is unagi" }`

You can use this method, for example, to normalize underscored keys to camelized or other general-purpose normalizations. You will only need to implement `normalize` and manipulate the payload as desired.

For example, if the `IDs` under `"comments"` are provided as `_id` instead of `id`, you can specify how to normalize just the comments:

    import DS from 'ember-data';

    export default DS.RESTSerializer.extend({
      normalize(model, hash, prop) {
        if (prop === 'comments') {
          hash.id = hash._id;
          delete hash._id;
        }

        return this._super(...arguments);
      }
    });

On each call to the `normalize` method, the third parameter (`prop`) is always one of the keys that were in the original payload or in the result of another normalization as `normalizeResponse`.

#### Parameters:

- `modelClass` DS.Model
- `resourceHash` Object
- `prop` String

#### Returns:

Object:

### `normalizeArrayResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:432`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeCreateRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:362`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeDeleteRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:376`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindAllResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:292`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindBelongsToResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:306`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindHasManyResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:320`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindManyResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:334`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:264`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeQueryRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:278`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeQueryResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:348`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeRelationships`

() private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:734`

### `normalizeResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/json.js:204`

Available since 1.13.0

The `normalizeResponse` method is used to normalize a payload from the server to a JSON-API Document.

http://jsonapi.org/format/#document-structure

This method delegates to a more specific normalize method based on the `requestType`.

To override this method with a custom one, make sure to call `return this._super(store, primaryModelClass, payload, id, requestType)` with your pre-processed data.

Here's an example of using `normalizeResponse` manually:

    socket.on('message', function(message) {
      var data = message.data;
      var modelClass = store.modelFor(data.modelName);
      var serializer = store.serializerFor(data.modelName);
      var normalized = serializer.normalizeSingleResponse(store, modelClass, data, data.id);

      store.push(normalized);
    });

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeSaveResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:404`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeSingleResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:418`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeUpdateRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:390`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeUsingDeclaredMapping`

() private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:757`

### `payloadKeyFromModelName`

(

- `modelName`

)
String

Defined in `addon/serializers/rest.js:685`

You can use `payloadKeyFromModelName` to override the root key for an outgoing request. By default, the RESTSerializer returns a camelized version of the model's name.

For a model called TacoParty, its `modelName` would be the string `taco-party`. The RESTSerializer will send it to the server with `tacoParty` as the root key in the JSON payload:

    {
      "tacoParty": {
        "id": "1",
        "location": "Matthew Beale's House"
      }
    }

For example, your server may expect dasherized root objects:

    import DS from 'ember-data';
    import { dasherize } from '@ember/string';

    export default DS.RESTSerializer.extend({
      payloadKeyFromModelName(modelName) {
        return dasherize(modelName);
      }
    });

Given a `TacoParty` model, calling `save` on it would produce an outgoing request like:

    {
      "taco-party": {
        "id": "1",
        "location": "Matthew Beale's House"
      }
    }

#### Parameters:

- `modelName` String

#### Returns:

String:

### `pushPayload`

(

- `store`
- `payload`

)

Defined in `addon/serializers/rest.js:374`

This method allows you to push a payload containing top-level collections of records organized per type.

    {
      "posts": [{
        "id": "1",
        "title": "Rails is omakase",
        "author", "1",
        "comments": [ "1" ]
      }],
      "comments": [{
        "id": "1",
        "body": "FIRST"
      }],
      "users": [{
        "id": "1",
        "name": "@d2h"
      }]
    }

It will first normalize the payload, so you can use this to push in data streaming in from your server structured the same way that fetches and saves are structured.

#### Parameters:

- `store` DS.Store
- `payload` Object

### `serialize`

(

- `snapshot`
- `options`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/rest.js:498`

Called when a record is saved in order to convert the record into JSON.

By default, it creates a JSON object with a key for each attribute and belongsTo relationship.

For example, consider this model:

    import DS from 'ember-data';

    export default DS.Model.extend({
      title: DS.attr(),
      body: DS.attr(),

      author: DS.belongsTo('user')
    });

The default serialization would create a JSON object like:

    {
      "title": "Rails is unagi",
      "body": "Rails? Omakase? O_O",
      "author": 12
    }

By default, attributes are passed through as-is, unless you specified an attribute type (`DS.attr('date')`). If you specify a transform, the JavaScript value will be serialized when inserted into the JSON hash.

By default, belongs-to relationships are converted into IDs when inserted into the JSON hash.

## IDs

`serialize` takes an options hash with a single option: `includeId`. If this option is `true`, `serialize` will, by default include the ID in the JSON object it builds.

The adapter passes in `includeId: true` when serializing a record for `createRecord`, but not for `updateRecord`.

## Customization

Your server may expect a different JSON format than the built-in serialization format.

In that case, you can implement `serialize` yourself and return a JSON hash of your choosing.

    import DS from 'ember-data';

    export default DS.RESTSerializer.extend({
      serialize(snapshot, options) {
        var json = {
          POST_TTL: snapshot.attr('title'),
          POST_BDY: snapshot.attr('body'),
          POST_CMS: snapshot.hasMany('comments', { ids: true })
        };

        if (options.includeId) {
          json.POST_ID_ = snapshot.id;
        }

        return json;
      }
    });

## Customizing an App-Wide Serializer

If you want to define a serializer for your entire application, you'll probably want to use `eachAttribute` and `eachRelationship` on the record.

    import DS from 'ember-data';
    import { pluralize } from 'ember-inflector';

    export default DS.RESTSerializer.extend({
      serialize(snapshot, options) {
        var json = {};

        snapshot.eachAttribute(function(name) {
          json[serverAttributeName(name)] = snapshot.attr(name);
        });

        snapshot.eachRelationship(function(name, relationship) {
          if (relationship.kind === 'hasMany') {
            json[serverHasManyName(name)] = snapshot.hasMany(name, { ids: true });
          }
        });

        if (options.includeId) {
          json.ID_ = snapshot.id;
        }

        return json;
      }
    });

    function serverAttributeName(attribute) {
      return attribute.underscore().toUpperCase();
    }

    function serverHasManyName(name) {
      return serverAttributeName(singularize(name)) + "_IDS";
    }

This serializer will generate JSON that looks like this:

    {
      "TITLE": "Rails is omakase",
      "BODY": "Yep. Omakase.",
      "COMMENT_IDS": [ 1, 2, 3 ]
    }

## Tweaking the Default JSON

If you just want to do some small tweaks on the default JSON, you can call super first and make the tweaks on the returned JSON.

    import DS from 'ember-data';

    export default DS.RESTSerializer.extend({
      serialize(snapshot, options) {
        var json = this._super(snapshot, options);

        json.subject = json.title;
        delete json.title;

        return json;
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `options` Object

#### Returns:

Object:

json

### `serializeAttribute`

(

- `snapshot`
- `json`
- `key`
- `attribute`

)

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1093`

`serializeAttribute` can be used to customize how `DS.attr` properties are serialized

For example if you wanted to ensure all your attributes were always serialized as properties on an `attributes` object you could write:

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serializeAttribute(snapshot, json, key, attributes) {
        json.attributes = json.attributes || {};
        this._super(snapshot, json.attributes, key, attributes);
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `key` String
- `attribute` Object

### `serializeBelongsTo`

(

- `snapshot`
- `json`
- `relationship`

)

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1139`

`serializeBelongsTo` can be used to customize how `DS.belongsTo` properties are serialized.

Example

    import DS from 'ember-data';
    import { isNone } from '@ember/utils';

    export default DS.JSONSerializer.extend({
      serializeBelongsTo(snapshot, json, relationship) {
        var key = relationship.key;
        var belongsTo = snapshot.belongsTo(key);

        key = this.keyForRelationship ? this.keyForRelationship(key, "belongsTo", "serialize") : key;

        json[key] = isNone(belongsTo) ? belongsTo : belongsTo.record.toJSON();
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `serializeHasMany`

(

- `snapshot`
- `json`
- `relationship`

)

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1192`

`serializeHasMany` can be used to customize how `DS.hasMany` properties are serialized.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serializeHasMany(snapshot, json, relationship) {
        var key = relationship.key;
        if (key === 'comments') {
          return;
        } else {
          this._super(...arguments);
        }
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `serializeIntoHash`

(

- `hash`
- `typeClass`
- `snapshot`
- `options`

)

Inherited from DS.JSONSerializer but overwritten in `addon/serializers/rest.js:654`

You can use this method to customize the root keys serialized into the JSON. The hash property should be modified by reference (possibly using something like _.extend) By default the REST Serializer sends the modelName of a model, which is a camelized version of the name.

For example, your server may expect underscored root objects.

    import DS from 'ember-data';
    import { decamelize } from '@ember/string';

    export default DS.RESTSerializer.extend({
      serializeIntoHash(data, type, record, options) {
        var root = decamelize(type.modelName);
        data[root] = this.serialize(record, options);
      }
    });

#### Parameters:

- `hash` Object
- `typeClass` DS.Model
- `snapshot` DS.Snapshot
- `options` Object

### `serializePolymorphicType`

(

- `snapshot`
- `json`
- `relationship`

)

Inherited from DS.JSONSerializer but overwritten in `addon/serializers/rest.js:735`

You can use this method to customize how polymorphic objects are serialized. By default the REST Serializer creates the key by appending `Type` to the attribute and value from the model's camelcased model name.

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `shouldSerializeHasMany`

(

- `snapshot`
- `key`
- `relationshipType`

)
Boolean

Inherited from DS.JSONSerializer: `addon/serializers/json.js:860`

Check if the given hasMany relationship should be serialized

By default only many-to-many and many-to-none relationships are serialized. This could be configured per relationship by Serializer's `attrs` object.

#### Parameters:

- `snapshot` DS.Snapshot
- `key` String
- `relationshipType` String

#### Returns:

Boolean:

true if the hasMany relationship should be serialized

### `transformFor`

(

- `attributeType`
- `skipAssertion`

)
DS.Transform private

Inherited from DS.JSONSerializer: `addon/serializers/json.js:1486`

#### Parameters:

- `attributeType` String
- `skipAssertion` Boolean

#### Returns:

DS.Transform:

transform

## Properties

### `attrs`

Object

Inherited from DS.JSONSerializer: `addon/serializers/json.js:107`

The `attrs` object can be used to declare a simple mapping between property names on `DS.Model` records and payload keys in the serialized JSON object representing the record. An object with the property `key` can also be used to designate the attribute's key on the response payload.

Example

    import DS from 'ember-data';

    export default DS.Model.extend({
      firstName: DS.attr('string'),
      lastName: DS.attr('string'),
      occupation: DS.attr('string'),
      admin: DS.attr('boolean')
    });

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      attrs: {
        admin: 'is_admin',
        occupation: { key: 'career' }
      }
    });

You can also remove attributes and relationships by setting the `serialize` key to `false` in your mapping object.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      attrs: {
        admin: { serialize: false },
        occupation: { key: 'career' }
      }
    });

When serialized:

    {
      "firstName": "Harry",
      "lastName": "Houdini",
      "career": "magician"
    }

Note that the `admin` is now not included in the payload.

Setting `serialize` to `true` enforces serialization for hasMany relationships even if it's neither a many-to-many nor many-to-none relationship.

### `primaryKey`

String

Inherited from DS.JSONSerializer: `addon/serializers/json.js:83`

The `primaryKey` is used when serializing and deserializing data. Ember Data always uses the `id` property to store the id of the record. The external source may not always follow this convention. In these cases it is useful to override the `primaryKey` property to match the `primaryKey` of your external store.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      primaryKey: '_id'
    });

Default: 'id'

### `store`

DS.Store public

Inherited from DS.Serializer: `addon/serializer.js:28`

The `store` property is the application's `store` that contains all records. It can be used to look up serializers for other model types that may be nested inside the payload response. Example: ```js Serializer.extend({ extractRelationship(relationshipModelName, relationshipHash) { var modelClass = this.store.modelFor(relationshipModelName); var relationshipSerializer = this.store.serializerFor(relationshipModelName); return relationshipSerializer.normalize(modelClass, relationshipHash); } }); ```